--chart children
local HEChartSpellFrame = {};
local HEChartSpellIcon = {};
local HEChartSpellText = {};
local HEChartAxisBits = {};
HEChartPrevSpell = "xx";
local HEChartInit = false;

function HealingEstimator_GetSpellIcon(aSpell)
    for k,v in pairs(HealingEstimator.Spells) do
        if ( v.spell == aSpell ) then
            if ( v.icon ) then return v.icon; end
        end
    end
    return "Spell_Holy_Heal";
end

function HealingEstimatorMenu_ChartTrueMana_Toggle()
	--HealingEstimator_Print( true,HealingEstimatorChartTrueManaCheck:GetChecked() );
	HealingEstimator_doChart();
end

function HealingEstimator_showChart()
    -- set talent slider bits
    if ( HealingEstimator.PlayerClass == HE_CL_PRIEST ) then
        HealingEstimatorChartTE1SliderHigh:SetText("5");
        HealingEstimatorChartTE1SliderLow:SetText("0");
        HealingEstimatorChartTE1Slider:SetMinMaxValues(0,5);
        HealingEstimatorChartTE1Slider:SetValueStep(1);
        local talList = HealingEstimator_GetHealTalentsByClass( HealingEstimator.PlayerClass )
        HealingEstimatorChartTE1Slider:SetValue( talList.EmpoweredHealing );
        HealingEstimatorChartTE1SliderText:SetText(HealingEstimatorChartTE1Slider:GetValue().."/5 Empowered Healing");
        HealingEstimatorChartTE1Slider.tooltip = "Ranks in Empowered Healing.";
        
        HealingEstimatorChartTE2Slider:Hide();
        
        HealingEstimatorChartTI1SliderHigh:SetText("5");
        HealingEstimatorChartTI1SliderLow:SetText("0");
        HealingEstimatorChartTI1Slider:SetMinMaxValues(0,5);
        HealingEstimatorChartTI1Slider:SetValueStep(1);
        HealingEstimatorChartTI1Slider:SetValue( talList.SpiritualHealing );
        HealingEstimatorChartTI1SliderText:SetText(HealingEstimatorChartTI1Slider:GetValue().."/5 Spiritual Healing");
        HealingEstimatorChartTI1Slider.tooltip = "Ranks in Spiritual Healing.";
        
        HealingEstimatorChartTI2SliderHigh:SetText("3");
        HealingEstimatorChartTI2SliderLow:SetText("0");
        HealingEstimatorChartTI2Slider:SetMinMaxValues(0,3);
        HealingEstimatorChartTI2Slider:SetValueStep(1);
        HealingEstimatorChartTI2Slider:SetValue( talList.ImprovedRenew );
        HealingEstimatorChartTI2SliderText:SetText(HealingEstimatorChartTI2Slider:GetValue().."/3 Improved Renew");
        HealingEstimatorChartTI2Slider.tooltip = "Ranks in Improved Renew.";
    else
        -- hide all the sliders until we add code for druid,paladin,shaman talents
        HealingEstimatorChartTE1Slider:Hide();
        HealingEstimatorChartTE2Slider:Hide();
        HealingEstimatorChartTI1Slider:Hide();
        HealingEstimatorChartTI2Slider:Hide();
    end
    
    -- mana regen slider
    local baseregen, castingregen = GetManaRegen();
    castingregen = floor( (castingregen * 5.0) + 0.5);
    HealingEstimatorChartRegenSliderText:SetText( castingregen.." mana per 5 sec" );
    HealingEstimatorChartRegenSliderHigh:SetText( "x2" );
    HealingEstimatorChartRegenSliderLow:SetText( "zero" );
    HealingEstimatorChartRegenSlider:SetMinMaxValues( 0 , 2 );
    HealingEstimatorChartRegenSlider:SetValueStep( 0.1 );
    HealingEstimatorChartRegenSlider:SetValue( 1 );
    HealingEstimatorChartRegenSlider.tooltip = "Mana regeneration per five seconds, within the 5-second casting rule, as a multiple of your current real value.";
    
end

function HealingEstimator_doChart()
    -- charts hpm and hps for primary healing spells, across ranks
    
    if ( HealingEstimator.PlayerClass == HE_CL_PRIEST ) then
        local adjTE1 = HealingEstimatorChartTE1Slider:GetValue();
        HealingEstimatorChartTE1SliderText:SetText(adjTE1.."/5 Empowered Healing");
        
        local adjTI1 = HealingEstimatorChartTI1Slider:GetValue();
        HealingEstimatorChartTI1SliderText:SetText(adjTI1.."/5 Spiritual Healing");
        
        local adjTI2 = HealingEstimatorChartTI2Slider:GetValue();
        HealingEstimatorChartTI2SliderText:SetText(adjTI2.."/3 Improved Renew");
        
    end
    
    -- flag for true mana calculations
    local fTrueMana = HealingEstimatorChartTrueManaCheck:GetChecked();
    
    -- mana regen slider
    local baseregen, castingregen = GetManaRegen();
    baseregen = floor( (baseregen * 5.0) + 0.5);
    castingregen = castingregen * 5.0;
    local castingregen = floor( ( HealingEstimatorChartRegenSlider:GetValue()*castingregen ) + 0.5 );
    HealingEstimatorChartRegenSliderText:SetText( castingregen.." mana per 5 sec" );
    
    -- bonus healing slider
    local temp = HealingEstimatorChartBonusHealingSlider:GetValue()*GetSpellBonusHealing();
        HealingEstimatorChartBonusHealingSliderText:SetText(format("%.0f",temp).." Bonus healing");
    
    local theSpellName = HEChartSpellName;
    if ( HEChartPrevSpell ~= theSpellName ) then
    
        -- Hide all children
        local rankcount = table.maxn(HEChartSpellFrame);
        for i = 1,rankcount do
            HEChartSpellFrame[i]:Hide();
        end
        
        -- reinitialize
        HEChartPrevSpell = theSpellName;
        HEChartInit = false;
    end
    
    local minRank = 1;
    local maxRank = HealingEstimator_FindMaxRank(theSpellName);
    if ( maxRank == 0 ) then
        -- no ranks known
        return;
    end
    
    local isHOT = false;
    local icon = "Interface\\Icons\\Spell_Shadow_LifeDrain.blp";
    icon = "Interface\\Icons\\"..HealingEstimator_GetSpellIcon(theSpellName)..".blp";
    
    if ( theSpellName==HE_SPELL_Renew or theSpellName==HE_SPELL_Rejuvenation ) then
        isHOT = true;
    end
    
    local theHPM = {};
    local theHPS = {};
    local HealAverage = {};
    local ManaCost = {};
    local CastingTime = {};
    local healingCoefficient = {};
    
    -- go through each rank, get info, do calculations
    
    local aRank;
    local maxHPM=-1000;
    local maxHPMrank=0;
    local maxHPS=0;
    local maxHPSrank=0;
    local minHPM=10000;
    local minHPMrank=0;
    local minHPS=10000;
    local minHPSrank=0;
    for aRank = minRank,maxRank do
        --HealingEstimator_Print(true,aRank);
        -- get tooltip text
        HealingEstimator_StoreSpellTip(theSpellName,"Rank "..aRank);
        
        -- Get spell healing average
        local healtemp = 1;
        local duration = 1.5;
        local Text=HealingEstimatorTooltipTextLeft4:GetText();
        
        if (isHOT) then
            -- HOT
            if (Text) then
                for t1,t2 in string.gmatch(Text, HealingEstimatorLoc.HOTValue) do
                    if (t2 == nil) then t2 = t1; end
                    healtemp=t1;
                    duration=t2;
                    break;
                end
            end
        else
            -- not HOT
            if (Text) then
                for t1,t2 in string.gmatch(Text, HealingEstimatorLoc.HealValue) do
                    healtemp=(t1+t2)/2;
                    break;
                end
            end
        end        
        
        -- compute predicted average non-crit heal amount
        local castlevel, basecoeff, altcoeff, learnlevel = HealingEstimator_GetCastLevel(theSpellName,aRank);
        local currTalents = HealingEstimator_GetHealTalentsByClass(HealingEstimator.PlayerClass);
        
        -- insert adjusted talents from slider values
        currTalents.EmpoweredHealing = HealingEstimatorChartTE1Slider:GetValue();
        currTalents.SpiritualHealing = HealingEstimatorChartTI1Slider:GetValue();
        currTalents.ImprovedRenew = HealingEstimatorChartTI2Slider:GetValue();
        
        local adjBonusHealing = GetSpellBonusHealing() * HealingEstimatorChartBonusHealingSlider:GetValue();
        
        local predictedheal,effbonuscoeff = HealingEstimator_GetHealAfterTalents( theSpellName , healtemp , basecoeff , castlevel , learnlevel , HealingEstimator.PlayerClass , currTalents , adjBonusHealing );
        
        --local predictedheal, castlevel, effcoeff = HealingEstimator_CalcAvgBonusHeal( theSpellName , aRank , healtemp , false );
        
        HealAverage[aRank] = predictedheal;
        healingCoefficient[aRank] = effbonuscoeff;
        
         -- find casting time
       local casttime;
       local casttext = HealingEstimatorTooltipTextLeft3:GetText();
       if (casttext ~= HealingEstimatorLoc.Instant) then
            for t1 in string.gmatch(casttext, HealingEstimatorLoc.Casttime) do
                casttime=t1;
                break;
            end
        else
            -- is an instant cast
            casttime = 1.5;   -- global cooldown
        end
        CastingTime[aRank] = casttime;
        
        -- get mana cost
       local manacost = HealingEstimatorTooltipTextLeft2:GetText();
       manacostlen = strlen(manacost);
       manacost = strsub(manacost , 1 , manacostlen-4 );
       
       -- true mana cost code
       if ( fTrueMana ) then
            manacost = manacost - ( castingregen/5 * casttime );
            if isHOT then
                manacost = manacost - ( castingregen/5 * duration );
            end
       end
       
       ManaCost[aRank] = manacost;
        
        -- compute HPM and HPS
        if ( not fTrueMana ) then
            theHPM[aRank] = HealAverage[aRank]/ManaCost[aRank];
        else
            theHPM[aRank] = -ManaCost[aRank]/HealAverage[aRank];
        end
        
        if ( not isHOT ) then
            theHPS[aRank] = HealAverage[aRank]/CastingTime[aRank];
        else
            -- is HOT
            theHPS[aRank] = HealAverage[aRank]/duration;
        end
        
        --HealingEstimator_Print(true,aRank.."/"..HealAverage[aRank].."/"..ManaCost[aRank].."/"..CastingTime[aRank]);
        --HealingEstimator_Print(true,"  /"..theHPM[aRank].."/"..theHPS[aRank]);
        
        if ( maxHPM < theHPM[aRank] ) then
            maxHPM = theHPM[aRank];
            maxHPMrank = aRank;
        end
        if ( maxHPS < theHPS[aRank] ) then
            maxHPS = theHPS[aRank];
            maxHPSrank = aRank;
        end
        
        if ( minHPM > theHPM[aRank] ) then
            minHPM = theHPM[aRank];
            minHPMrank = aRank;
        end
        if ( minHPS > theHPS[aRank] ) then
            minHPS = theHPS[aRank];
            minHPSrank = aRank;
        end
        
	end -- rank loop
	
	local f = HealingEstimatorChartFrame;
	local framew = 500;
	local frameh = 500;
    
    -- make spell dot and rank label
    local chartwidth = 300;
    local chartheight = 300;
    local insetx = (framew - chartwidth)/2;
    local insety = (frameh - chartheight)/2;
    
    
    ----------------
    -- populate child frames
    for aRank = minRank,maxRank do 
        if ( not HEChartInit ) then
            if (HEChartSpellFrame[aRank] == nil) then HEChartSpellFrame[aRank] = CreateFrame( "Frame" , nil , f ); end
            if (HEChartSpellIcon[aRank] == nil) then HEChartSpellIcon[aRank] = HEChartSpellFrame[aRank]:CreateTexture(nil,"ARTWORK"); end
            if (HEChartSpellText[aRank] == nil) then HEChartSpellText[aRank] = HEChartSpellFrame[aRank]:CreateFontString(nil , "OVERLAY" ); end
        end
        
        -- setup icon parent frame
        HEChartSpellFrame[aRank]:SetFrameStrata("HIGH");
        HEChartSpellFrame[aRank]:SetWidth(16);
        HEChartSpellFrame[aRank]:SetHeight(16);
        HEChartSpellFrame[aRank].myRank = aRank;
        
        local x = ( theHPM[aRank] - minHPM )/(maxHPM - minHPM) * chartwidth + (framew-chartwidth)/2;
        local y = ( theHPS[aRank] - minHPS )/(maxHPS - minHPS) * chartheight + (frameh-chartheight)/2;
        HEChartSpellFrame[aRank]:SetPoint("BOTTOMLEFT", x , y );
        HEChartSpellFrame[aRank]:Show();
        
        -- create the icon
        HEChartSpellIcon[aRank]:SetTexture(icon);
        HEChartSpellIcon[aRank]:SetWidth(16) 
        HEChartSpellIcon[aRank]:SetHeight(16)
        HEChartSpellIcon[aRank]:SetPoint("CENTER", 0 , 0 );
        HEChartSpellIcon[aRank]:Show();
        
        -- create the rank label
        HEChartSpellText[aRank]:SetFontObject(NumberFontNormalSmall);
        HEChartSpellText[aRank]:SetText(aRank);
        HEChartSpellText[aRank]:SetPoint("CENTER", 7 , 0 );
        HEChartSpellText[aRank]:Show();
        
        -- register for mouse event
        HEChartSpellFrame[aRank]:EnableMouse(true);
        
        HEChartSpellFrame[aRank]:SetScript("OnEnter" , 
            function() 
                GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT"); 
                GameTooltip:AddLine( theSpellName.." Rank "..this.myRank , 1, 1, 1 );
                GameTooltip:AddDoubleLine( "Average non-crit heal" , HealingEstimator_Round( HealAverage[this.myRank] ) );
                GameTooltip:AddDoubleLine( "Health-per-second" , HealingEstimator_Round( theHPS[this.myRank] ) );
                if not fTrueMana then
                    GameTooltip:AddDoubleLine( "Health-per-mana" , format("%.2f",theHPM[this.myRank]) );
                else
                    GameTooltip:AddDoubleLine( "∆Mana-per-health" , format("%.2f",theHPM[this.myRank]) );
                end
                GameTooltip:AddDoubleLine( "Bonus healing coefficient" , format("%.2f",healingCoefficient[this.myRank]) );
                GameTooltip:Show(); 
            end );
        
        HEChartSpellFrame[aRank]:SetScript("OnLeave" , function() GameTooltip:Hide(); end );
	end
	
	-- axis labels
	--local xs1,xs2,ys1,ys2,lsx,lsy;
	
	if ( not HEChartInit and HEChartAxisBits[1]==nil ) then
	   -- init axis bits
	   -- min x
	   HEChartAxisBits[1] = f:CreateFontString(nil , "OVERLAY" );
	   -- max x
	   HEChartAxisBits[2] = f:CreateFontString(nil , "OVERLAY" );
	   -- min y
	   HEChartAxisBits[3] = f:CreateFontString(nil , "OVERLAY" );
	   -- max y
	   HEChartAxisBits[4] = f:CreateFontString(nil , "OVERLAY" );
	   -- x label
	   HEChartAxisBits[5] = f:CreateFontString(nil , "OVERLAY" );
	   -- y label
	   HEChartAxisBits[6] = f:CreateFontString(nil , "OVERLAY" );
	   -- x axis line
	   HEChartAxisBits[7] = f:CreateTexture("AxisLineX", "ARTWORK");
	   -- y axis line
	   HEChartAxisBits[8] = f:CreateTexture("AxisLineY", "ARTWORK");
	   -- zero HPM vertical line
	   HEChartAxisBits[9] = f:CreateTexture("HPMZeroLine", "ARTWORK");
	   
	   -- axis lines
        -- T        - Texture
        -- C        - Canvas Frame (for anchoring)
        -- sx,sy    - Coordinate of start of line
        -- ex,ey    - Coordinate of end of line
        -- w        - Width of line
        -- relPoint - Relative point on canvas to interpret coords (Default BOTTOMLEFT)
        --HEChartAxisBits[7]:SetTexture("Interface\\TaxiFrame\\UI-Taxi-Line");
        HEChartAxisBits[7]:SetTexture("Interface\\Addons\\HealingEstimator\\Axis-Line");
        DrawRouteLine(HEChartAxisBits[7], f, insetx, insety, frameh-insetx, insety, 1);
        HEChartAxisBits[7]:Show();
        
        HEChartAxisBits[8]:SetTexture("Interface\\Addons\\HealingEstimator\\Axis-Line");
        DrawRouteLine(HEChartAxisBits[8], f, insetx, insety, insetx, framew-insety, 1);
        HEChartAxisBits[8]:Show();
        
        HEChartAxisBits[9]:SetTexture("Interface\\Addons\\HealingEstimator\\Axis-Line");
        DrawRouteLine(HEChartAxisBits[9], f, insetx, insety, insetx, framew-insety, 1);
        --HEChartAxisBits[9]:Show();
	end
	
	-- move and show/hide zero MPH line
	if ( minHPM < 0 and maxHPM > 0 ) then
	   local zeroOffset = (-minHPM)/( maxHPM-minHPM )*chartwidth;
        DrawRouteLine(HEChartAxisBits[9], f, insetx + zeroOffset , insety, insetx + zeroOffset , framew-insety, 1);
        HEChartAxisBits[9]:Show();
    else
        -- hide it, because zero HPM not on screen
        HEChartAxisBits[9]:Hide();
    end
	
	-- min x
    HEChartAxisBits[1]:SetFontObject(NumberFontNormalSmall);
    HEChartAxisBits[1]:SetText( format("%.2f",minHPM) );
    HEChartAxisBits[1]:SetPoint("BOTTOMLEFT", (framew-chartwidth)/2 - 14 , (frameh-chartheight)/2 - 16 );
    HEChartAxisBits[1]:SetJustifyH("CENTER");
    HEChartAxisBits[1]:Show()
    
    -- max x
    HEChartAxisBits[2]:SetFontObject(NumberFontNormalSmall);
    HEChartAxisBits[2]:SetText( format("%.2f",maxHPM) );
    HEChartAxisBits[2]:SetPoint("BOTTOMLEFT", framew - (framew-chartwidth)/2 - 14 , (frameh-chartheight)/2 - 16);
    HEChartAxisBits[2]:SetJustifyH("CENTER");
    HEChartAxisBits[2]:Show()
    
    -- min y
    HEChartAxisBits[3]:SetFontObject(NumberFontNormalSmall);
    HEChartAxisBits[3]:SetText( format("%.0f",minHPS) );
    HEChartAxisBits[3]:SetPoint("BOTTOMLEFT", (framew-chartwidth)/2 - 42 , (frameh-chartheight)/2 - 4);
    HEChartAxisBits[3]:SetJustifyH("RIGHT");
    HEChartAxisBits[3]:Show()
    
    -- max y
    HEChartAxisBits[4]:SetFontObject(NumberFontNormalSmall);
    HEChartAxisBits[4]:SetText( format("%.0f",maxHPS) );
    HEChartAxisBits[4]:SetPoint("BOTTOMLEFT", (framew-chartwidth)/2 - 42 , frameh - (frameh-chartheight)/2 );
    HEChartAxisBits[4]:SetJustifyH("RIGHT");
    HEChartAxisBits[4]:Show()
    
    -- axis labels
    HEChartAxisBits[5]:SetFontObject(NumberFontNormalSmall);
    if ( fTrueMana ) then
        HEChartAxisBits[5]:SetText( "Change in mana per health" );
    else
        HEChartAxisBits[5]:SetText( "Health-per-mana" );
    end
    HEChartAxisBits[5]:SetPoint("BOTTOMLEFT", (framew)/2 - 50 , (frameh-chartheight)/2 - 32 );
    HEChartAxisBits[5]:SetJustifyH("CENTER");
    HEChartAxisBits[5]:Show()
    
    HEChartAxisBits[6]:SetFontObject(NumberFontNormalSmall);
    HEChartAxisBits[6]:SetText( "HPS" );
    HEChartAxisBits[6]:SetPoint("BOTTOMLEFT", (framew-chartwidth)/2 - 45 , (frameh)/2 );
    HEChartAxisBits[6]:SetJustifyH("CENTER");
    HEChartAxisBits[6]:Show()
    
    -- final housekeeping
    HEChartPrevSpell = theSpellName;
    HEChartInit = true; -- flag that we've populated child frames
	
end

function HealingEstimator_closeChart()
    PlaySound("igCharacterInfoClose");
end

function HealingEstimatorChartFrameDropMenu_OnLoad()
    if ( not HealingEstimator_IsHealingClass(UnitClass("player")) ) then
		return;
	end
    
	UIDropDownMenu_Initialize(this, HealingEstimatorChartFrameDropMenu_Initialize);
	UIDropDownMenu_SetSelectedValue(this, HEChartSpellName);
	HealingEstimatorChartFrameDropMenu.tooltip = "Display efficiency and throughput data for all known ranks of "..UIDropDownMenu_GetSelectedValue(HealingEstimatorChartFrameDropMenu)..".";
	UIDropDownMenu_SetWidth(120, HealingEstimatorChartFrameDropMenu);
end

function HealingEstimatorChartFrameDropMenu_OnClick()
	UIDropDownMenu_SetSelectedValue(HealingEstimatorChartFrameDropMenu, this.value);
	HEChartSpellName = UIDropDownMenu_GetSelectedValue(HealingEstimatorChartFrameDropMenu);
	HealingEstimatorChartFrameDropMenu.tooltip = "Display efficiency and throughput data for all known ranks of "..HEChartSpellName..".";
	HealingEstimator_doChart();
end

function HealingEstimatorChartFrameDropMenu_Initialize()
    if ( not HealingEstimator_IsHealingClass(UnitClass("player")) ) then
		return;
	end

	local selectedValue = UIDropDownMenu_GetSelectedValue(HealingEstimatorChartFrameDropMenu);
	local info = UIDropDownMenu_CreateInfo();
	
	-- add spell names from class data
	for i,aSpell in pairs(HealingEstimator.Spells) do
	   if ( aSpell.icon ) then
           info.text = aSpell.spell;
            info.func = HealingEstimatorChartFrameDropMenu_OnClick;
            info.value = aSpell.spell;
            if ( info.value == selectedValue ) then
                info.checked = 1;
            else
                info.checked = nil;
            end
            info.tooltipTitle = aSpell.spell;
            info.tooltipText = "Display efficiency and throughput data for all known ranks of "..aSpell.spell..".";
            UIDropDownMenu_AddButton(info);
        end
	end
    
end