--
-- Healing estimator FR localization
-- incomplete file
--

if(GetLocale()=="frFR") then

    --spell names
    HE_SPELL_FlashHeal = "Soins rapides";
    HE_SPELL_Heal = "Soins";
    HE_SPELL_GreaterHeal = "Soins sup\195\169rieurs";
    HE_SPELL_Renew = "R\195\169novation";
    HE_SPELL_HealingTouch = "Toucher gu\195\169risseur";
    HE_SPELL_Regrowth = "R\195\169tablissement";
    HE_SPELL_Rejuvenation = "R\195\169cup\195\169ration";
    HE_SPELL_HolyLight = "Lumi\195\168re sacr\195\169e";
    HE_SPELL_FlashOfLight = "Eclair lumineux";
    
    HE_SPELL_BlessingOfLight = "B\195\169n\195\169diction de lumi\195\168re";
    HE_SPELL_GrBlessingOfLight = "B\195\169n\195\169diction de lumi\195\168re sup\195\169rieure";
    HE_SPELL_FearWard = "Gardien de peur";
    
    --HE_CL_DRUID = "Druide";
    --HE_CL_HUNTER = "Chasseur";
    --HE_CL_MAGE = "Mage";
    --HE_CL_PALADIN = "Paladin";
    --HE_CL_PRIEST = "Pr\195\170tre";
    --HE_CL_ROGUE = "Voleur";
    --HE_CL_SHAMAN = "Chaman";
    --HE_CL_WARLOCK = "D\195\169monistes";
    --HE_CL_WARRIOR = "Guerrier";

	-- Localize other texts
	HealingEstimatorLoc = 
		{
		Welcome		= "Healing Estimator "..HEALINGESTIMATOR_VERSION.." loaded";
		
		-- This infomation is readed from tooltip
		HealValue	= "(%d+) \195\160 (%d+)";
		RankTxt		= "%((Rang %d+)%)";
		RankTooltip	= "Rang (%d+)";
		TargetName	= "<Target name>";
		
		HOTValue   = "(%d+) en (%d+)";
	    Casttime   = "(.+) sec d'incantation";
	    Instant    = "Incantation imm\195\169diate";
		
		-- Healing texts in combat log
		-- French locale has own functions to parse these
		CritHeal 	= "Votre (.+) soigne (.+) avec un effet critique et lui rend (%d+)%. points de vie.";
		NormHeal	= "Votre (.+) soigne (.+) pour (%d+)%. points de vie.";
		HotSelf		= "";
		HotOther	= "Votre (.+) rend (%d+) points de vie  (.+)%.";
		YouText 	= "Vous";
		
		-- Healing classes
		HealingClasses={"Pr\195\170tre", "Druide", "Chaman", "Paladin"};
		HealingSpells=
			{
			"Soins rapides", "Soins sup\195\169rieurs", "Soins inf\195\169rieurs", "Soins",
			"Toucher gu\195\169risseur", "R\195\169tablissement",
			"Feu sacr\195\169e", "Eclair lumineux",
			"Vague de Soins", "Vague de soins mineurs"
			};
		
		-- Menu text
		Scale			= "Healing bar scale ";
		Limit			= "Overheal warning at ";
		IconPos			= "Position";
		OverhealTitle	= "Healing meter config";
		BarTitle		= "Healing bar";
		MinimapTitle	= "Minimap button";
		ShowText		= "Show";
		HideText		= "Hide";
		ResetPosTooltip	= "Resets the healing bar position";
		HideTooltip		= "Hides/shows the minimap button";
		ClearTooltip	= "Clears current healing/overhealing data";
		
		HideMeter		= "Overhealing meter hidden, use /heal or /healingestimator command to show menu.";
		ShowMeter		= "Overhealing meter visible.";
		};
end

--------------------------------------------------------------------
-- Localized functions
--------------------------------------------------------------------

--------------------------------------------------------------------
-- ParseSelfBuff
-- Reads the heal info from combat log message
-- Returns Spell, Spell target, Heal amount, info about crit
--
function HealingEstimator_ParseSelfBuff_FR(Msg)
	local Spell,Target,Heal;
	for Spell, Target, Heal in string.gmatch(arg1, "Votre (.+) soigne (.+) avec un effet critique et lui rend (%d+) points de vie.") do
		-- Self Crit Heal;
		return Spell,Target,Heal,true;
	end

	for Spell, Heal in string.gmatch(arg1, "Votre (.+) vous soigne pour (%d+) points de vie.") do
		-- Self Heal
		Target=UnitName("Player");
		return Spell,Target,Heal,false;
	end

	for Spell, Target, Heal in string.gmatch(arg1, "Votre (.+) soigne (.+) pour (%d+) points de vie.") do
		-- Friendly Heal
		if (string.lower(Target) == HealingEstimatorLoc.YouText) then 
			Target = UnitName("Player"); 
		end
		return Spell,Target,Heal,false;
	end

	return nil,nil,nil,false;
end

--------------------------------------------------------------------
-- ParsePeriodicSelfBuff
-- Reads the heal over time info from combat log message
-- Returns Spell, Spell target, Heal amount, info about crit
--
function HealingEstimator_ParsePeriodicSelfBuff_FR(Msg)
	local Spell,Target,Heal;
	for Spell, Heal in string.gmatch(arg1, "(.+) vous rend (%d+) points de vie.") do
		-- Self Hot
		Target=UnitName("Player");
		return Spell,Target,Heal,false;
	end
	for Spell, Heal, Target in string.gmatch(arg1, "Votre (.+) rend (%d+) points de vie \195\160 (.+).") do		
		-- Self Hot on Others
		return Spell,Target,Heal,false;
	end
	return nil,nil,nil,false;
end